#include <cmath>
#include <iostream>
#include "FourVector.h"

FourVector::~FourVector() {
  std::cout << "FourVector destructor called" << std::endl;
}
// ueberladene Konstruktoren 
FourVector::FourVector(){
  E=0.;Px=0.;Py=0.;Pz=0.;
  std::cout << "FourVector constructor I called" << std::endl; 
}
FourVector::FourVector(double e ){
  E=e; Px=0.;Py=0.;Pz=0.;
  std::cout << "FourVector constructor II called" << std::endl; 
}
FourVector::FourVector(double x, double y, double z){
  std::cout << "FourVector constructor III called" << std::endl; 
  E=0.; Px=x;Py=y;Pz=z;
}
FourVector::FourVector(double e,double x,double y, double z) : 
  E(e),Px(x),Py(y),Pz(z){  std::cout << "FourVector constructor IV called" << std::endl; }

// Die Funktionen werden jetzt ausserhalb der Klassendeinition geschrieben 
void FourVector::setE  (double e) { 
   E = e ;
}
void FourVector::setP (double x, double y, double z) { 
   Px = x ;
   Py = y ; 
   Pz = z;
} 
double FourVector::getEnergy(void) const {
   return E ;
}  
double FourVector::getMomentum (void) const {
   return sqrt (Px*Px + Py*Py + Pz*Pz); 
}
double FourVector::getMass(void) const {
   return sqrt(E*E - Px*Px - Py*Py - Pz*Pz);
}
/*
double  FourVector::SkalarProduct(const FourVector& u , const FourVector& v){
  double s = 0.;
  s = u.E * v.E - (v.Px*u.Px+v.Py*u.Py+v.Pz*u.Pz) ;
  return s ;
}
*/
double  FourVector::SkalarProduct(const FourVector& u){
  double s = 0.;
  s = u.E * this->E - (u.Px*this->Px+u.Py*this->Py+u.Pz*this->Pz) ;
  return s ;
}

// Overload + operator to add two fourvector objects.
FourVector FourVector::operator+(const FourVector& v) {
   FourVector vec;
   vec.E  = this->E  + v.E;
   vec.Px = this->Px + v.Px;
   vec.Py = this->Py + v.Py;
   vec.Pz = this->Pz + v.Pz;
   return vec;
}
// Overload - operator to subtract two fourvector objects.
FourVector FourVector::operator-(const FourVector& v) {
   FourVector vec;
   vec.E  = this->E  - v.E;
   vec.Px = this->Px - v.Px;
   vec.Py = this->Py - v.Py;
   vec.Pz = this->Pz - v.Pz;
   return vec;
}
// Overload - operator to a fourvector.
FourVector FourVector::operator-() {
   FourVector vec;
   vec.E  = -this->E;
   vec.Px = -this->Px;
   vec.Py = -this->Py;
   vec.Pz = -this->Pz;
   return vec;
}
// Overload * operator to add two fourvector objects.
FourVector FourVector::operator*(double m) {
   FourVector vec;
   vec.E  = this->E * m  ;
   vec.Px = this->Px * m ;
   vec.Py = this->Py * m ;
   vec.Pz = this->Pz * m ;
   return vec ;
}
// Overload += operator.
FourVector FourVector::operator+=(const FourVector& v) {
   FourVector vec;
   this->E  += v.E;
   this->Px += v.Px;
   this->Py += v.Py;
   this->Pz += v.Pz;
   return *this;
}
