#include <iostream>
#include <TDirectory.h>

class FourVector
{
   public:
   FourVector();
   FourVector(double e );
   FourVector(double e, double x, double y, double z);
   FourVector(double x , double y, double z);
   ~FourVector();
   void setE (double e);
   void setP (double x, double y, double z);
   double getEnergy(void) const ;
   double getMomentum (void) const;
   double getMass (void) const;
   double SkalarProduct(const FourVector& u);
  //static double SkalarProduct(const FourVector& u , const FourVector& v);
   FourVector operator+(const FourVector & v);
   FourVector operator+=(const FourVector& v);
   FourVector operator-(const FourVector& v); 
   FourVector operator*(double m ); 
   FourVector operator-();
   // In order to get the correct schema evolution a versioning
   // is supported which tracks class changes.
   ClassDef(FourVector,1); // FourVector class to be used within ROOT  
 
   private:
   // All variable should have comment which are then used as reflection data
      double  E;  // Energy
      double  Px; // x component of the momentum
      double  Py; // y component of the momentum
      double  Pz; // z component of the momentum
      
//ClassImp(FourVector);
};
