#include <iostream>
#include <TFile.h>
#include <TDirectory.h>
#include <TTree.h>

#include "FourVector.h"
using namespace std;


#ifndef __CLING__  /* the following code will be invisible for CINT interpreter*/
// adjust to filename !!!
void readObject();

int main(int argc, char* argv[])
{
  readObject() ;
  return 0 ;
}
#endif   // end ignore



void readObject(){
  FourVector *pi, *K;

  TFile inFile ("writeObject.root","READ");
  inFile.GetObject("pion",pi);
  inFile.GetObject("Kaon",K);
  cout << pi->getEnergy() << "    "  << K->getEnergy() << endl;

  // Get tree Object, the name of the tree needs to be specified
  TTree *tree = (TTree*) inFile.Get("tree");
  // List of branches
  TBranch *b_nEvent; 
  TBranch *b_E;  
  TBranch *b_p;  
  TBranch *b_lambda;
  
  // Initialize Variables
  int nEvent;
  double E; 
  double p[3];
  FourVector *l = new FourVector ;

  // Set Branch addresses
  tree->SetBranchAddress("nEvent", &nEvent, &b_nEvent);
  tree->SetBranchAddress("E", &E, &b_E);
  tree->SetBranchAddress("p", &p, &b_p);
  tree->SetBranchAddress("lambda", &l, &b_lambda);
  
  // Get Number of entries in the tree
  Long64_t nentries = tree->GetEntries();
  // read all entries
  for (Long64_t i=0;i<nentries;i++) {
     tree->GetEntry(i);
     cout << "Event " << nEvent << "  p[0] = " << p[0] << "   p[2] = " << p[2] << endl;
     cout << "FourVector: " << l->getEnergy() << "  " << l->getMomentum() << endl;
  }

  inFile.Close();
  return;
}
