#include <iostream>
#include <TRandom3.h>
#include <TFile.h>
#include <TDirectory.h>
#include <TTree.h>
#include <TH1.h>
#include "FourVector.h"

using namespace std;


#ifndef __CLING__  /* the following code will be invisible for CINT interpreter*/
// adjust to filename !!!
void writeObject();

int main(int argc, char* argv[])
{
  writeObject() ;
  return 0 ;
}
#endif   // end ignore

void writeObject(){
  FourVector pi, K(10.,4.,7.,12.);
  
  TRandom3 *R = new TRandom3();
  R->SetSeed(0); 
  TH1F *h = new TH1F ("myhist","Write Test",100,-5.,5.);
  h->FillRandom("gaus",10000);

  TFile outFile ("writeObject.root","RECREATE");

  outFile.WriteObject(&pi,"pion");
  outFile.WriteObject(&K,"Kaon");
  h->Write();

  // TTree Object
  TTree *tree = new TTree("tree","data tree");
  // Initialize branch
  int nEvent; tree->Branch("nEvent",&nEvent,"nEvent/I");
  double E;   tree->Branch("E",&E,"E/D");
  double p[3];tree->Branch("p",p,"p[3]/D");
  FourVector *l = new FourVector ; tree->Branch("lambda",&l);
  // Event Loop
  nEvent = 0 ;
  double m =0.134;
  
  for (int i = 0 ; i < 3 ; i++) {
    p[0] = R->Gaus(330.0,0.14);
    p[1] = R->Gaus(400.0,0.24);
    p[2] = R->Gaus(430.0,0.34);
    E = sqrt(p[0]*p[0]+p[1]*p[1]+p[2]*p[2] - m*m) ;
    l->setE(E);
    l->setP(p[0],p[1],p[2]);
    cout << "FourVector: " << l->getEnergy() << "  " << l->getMomentum() << endl;
    // Fill tree
    tree->Fill();
    nEvent++;
  } 

  // Write tree
  tree->Write();


  outFile.Close();
  return;
}
